Outbound Call Routing for CCNQ4 / Kwaoo.

In CCNQ4, OpenSIPS no longer does client-side call routing. All calls are forwarded to FreeSwitch, which decides how the call is handled (in other words, FreeSwitch implements the client-side dialplan).

This file describes the 

This is an acoustical-line profile set.

    module.exports = (name,egress_profile) ->

Profile selection
=================

Based on the X-CCNQ3-Number-Domain, select a particular context.

      context "context-#{name}", ->
        ###
        extension 'get destination', continue:true, ->
          condition 'destination_number', '^(.*)$', ->
            action 'set', 'destination_number=$1'
        ###

        extension "router", ->
          condition '${sip_h_X-CCNQ3-Number-Domain}', '^(.+)$', ->
            action 'curl', "#{provisioning}/${url_encode(endpoint:${sip_h_X-CCNQ3-Endpoint})} json get"
            action 'transfer', '${destination_number} XML ${sip_h_X-CCNQ3-Number-Domain}-${outbound_route}'

Send a 485 Ambiguous response when no Number-Domain is found.

            anti_action 'respond', '485'

End-user context for k-net (France)
===================================

This code was previously in `kwaoo-ccnq3` `common/opensips/fragments/kwaoo-special_drouting.cfg`

      context 'knet', ->
        extension 'privacy', ->
          condition 'destination_number', '^3651(.*)', ->
            action 'set', 'origination_privacy=screen+hide_name+hide_number'
            action 'transfer', '${destination_number} XML knet'

        extension 'voicemail', ->
          condition 'destination_number', '^123$', ->
            action 'redirect', "sofia/#{egress_profile}/"

End-user context for k-sys (Switzerland)
========================================

      context 'ksys', ->


Context for 3-digits centrex in France
======================================

      context 'centrex-knet', ->
        centrex 'knet'

      context 'centrex-ksys', ->
        centrex 'ksys'

    centrex = (name) ->

      extension 'presence-busy', ->
        condition ''

      extension 'external', ->
        condition 'destination_number', '^0(.*)+', ->
          action 'transfer', "$1 XML #{name}"

      extension 'internal', ->
        condition 'destination_number', '^([12]\d\d)$', ->

FIXME: target might have voicemail etc should we deal with it here?
FIXME: what about camp on etc.

            action 'bridge', "sofia/#{egress_profile}/$1@${caller_domain}"

        extension 'voicemail', ->
          condition 'destination_number', '^*86', ->

What headers do we need to set for voicemail?

            action 'bridge', "sofia/#{egress_profile}/"
